/*
 *  ca.c
 *  various functions neccesary for CA operation
 *  samuel judson | cryptography and network protocols | marlboro college
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <openssl/x509.h>
#include <openssl/evp.h>
#include <openssl/rsa.h>

#include "gen_cert"
#include "ca_attr.h"



/*
 *  Cert IO
 */



void read_pk(char* ca_key_path, pk_and_cert* pk_ct) {
  FILE* fp;
  fp = fopen(ca_key_path, "wb");
  
  fscanf(fp, "%s", pk_ct->private_key);
  fclose(fp);
}

void read_cert(char* ca_cert_path, pk_and_cert* pk_ct) {
  FILE* fp;
  fp = fopen(ca_cert_path, "wb");
  
  fscanf(fp, "%s", pk_ct->certificate);
  fclose(fp);
}

void write_pk(char key[512]) {
  FILE* fp;
  fp = fopen("key.pem", "wb");
  
  fprintf(fp, "%s", pk);
  fclose(fp);
}

void write_cert(char cert[512]) {
  FILE* fp;
  fp = fopen("cert.pem", "wb");
  
  fprintf(fp, "%s", cert);
  fclose(fp);
}



/*
 *  Create CA Certificate
 */



void create_ca_cert() {
  pk_and_cert* ss_cert;
  entity* ca;
  
  strcpy(ca->country, CA_COUNTRY);
  strcpy(ca->org, CA_ORG);
  strcpy(ca->org_unit, CA_ORG_UNIT);
  strcpy(ca->state, CA_STATE);
  strcpy(ca->common_name, CA_COMMON_NAME);
  strcpy(ca->locality, CA_LOCALITY);
  
  ss_cert = gen_ss_cert(ca);
 
  write_pk(ss_cert->private_key);
  write_cert(ss_cert->certificate);
}



/*
 *  Issue Certificate
 */



void issue_cert(entity* subject, char* ca_cert_path, char* ca_key_path) {
  pk_and_cert* ca;
  pk_and_cert* issued;
  
  read_pk(ca_key_path, ca);
  read_cert(ca_cert_path, ca);

  FILE* fp_pk;
  fp_pk = fmemopen(ca->private_key, 512, "wb");

  EVP_PKEY* ca_key = PEM_read_PrivateKey(fp_pk);

  FILE* fp_cert;
  fp_cert = fmemopen(ca->certificate, 512, "wb");
  
  X509* ca_cert = PEM_read_X509(fp_cert);

  issued = gen_ca_cert(subject, ca_cert, ca_key);

  write_pk(issued->private_key);
  write_cert(issued->certificate);
}
