/*
 *  gen_cert.h
 *  generate a new X.509 formatted cerificate.
 *  samuel judson | cryptography and network protocols | marlboro college
 */

typedef struct entity {
  char country[3];
  char org[33];
  char org_unit[33];
  char state[33];
  char common_name[33];
  char locality[33];
} entity;

typedef struct pk_and_cert {
  char private_key[512];
  char certificate[512];
} pk_and_cert;

pk_and_cert* gen_ss_cert(entity* info);
pk_and_cert* gen_ca_cert(entity* subject, X509* CA_cert, EVP_PKEY* CA_key);
