/*
 *  cert_lib/verify.c
 *  verify an X.509 certificate
 *  samuel judson | cryptography and network protocols | marlboro college
 */

#include <openssl/x509v3.h>
#include <openssl/bn.h>
#include <openssl/asn1.h>
#include <openssl/x509.h>
#include <openssl/x509_vfy.h>
#include <openssl/pem.h>
#include <openssl/bio.h>

#define T 1
#define F 0



/* 
 *  Verify Certificate
 */



int verify_cert(char* signed_cert, char* path_to_ca_certs) {
  FILE* fp_signed;
  fp_signed = fmemopen(signed_cert, strlen(signed_cert), "rb");
  X509* signed_cert = PEM_read_X509(fp, &X509);
 
  X509_STORE* CA_cert_store; 
  if (!(CA_cert_store = X509_STORE_new())) {
    perror("Error: Unable to create CA certificate store.");
    exit(-1);
  } 

  if (X509_STORE_load_locations(CA_cert_store, CA_CERT_LOC, NULL) != 1) {
    X509_STORE_free(CA_cert_store);
    perror("Error: Unable to load CA certificates.");
    exit(-1);
  }

  X509_STORE_CTX* signed_cert_store;
  if (!(signed_cert_store = X509_STORE_CTX_new())) {
    perror("Error: Unable to create signed certificate store.");
    exit(-1);
  } 
  
  if (X509_STORE_CTX_init(signed_cert_store, CA_cert_store, signed_cert, NULL) != 1) {
    X509_STORE_free(CA_cert_store);
    perror("Error: Unable to load CA certificates.");
    exit(-1);
  }

  fclose(fp_signed);
  
  return X509_verify_cert(signed_cert_store);
}
