/*
 *  dhe/dhe.c
 *  Diffie-Hellman Key Exchange
 *  samuel judson | cryptography and network protocols | marlboro college
 */

#include <gmp.h>



/*
 *  Compute Party (Our) Secret
 */


void dhe_compute_party_secret(mpz_t party_secret, mpz_t secret_key, mpz_t generator, mpz_t prime) {
  mpz_powm_sec(party_secret, generator, secret_key, prime);
}



/*
 *  Compute Shared Secret
 */



void dhe_compute_shared_secret(mpz_t shared_secret, mpz_t secret_key, mpz_t other_party_secret, mpz_t prime) {
  mpz_powm_sec(shared_secret, other_party_secret, secret_key, prime);
}












