/*
 * dhe_rsa.c
 * key exchange using DHE_RSA, where RSA is RSA-2048
 * samuel judson | cryptography and network protocols | marlboro college 
 */

#include <gmp.h>

typedef struct keys {
  mpz_t m_pri_exp;  // struct owner's private key
  mpz_t m_pub_exp;  // struct owner's public key
  mpz_t m_n;        // struct owner's modulus
  mpz_t o_pub_exp;  // other party's public key
  mpz_t o_n;        // other party's modulus
} keys;


void read_rsa_keyfile(char* path, keys* key_ptr, int pri);

void generate_rsa_key(keys* key_ptr);

void gen_party_secret(mpz_t party_secret, mpz_t hashed_party_secret, mpz_t signed_secret, keys* key_ptr, mpz_t dhe_rand_sec, mpz_t dhe_generator, mpz_t dhe_prime);

void gen_shared_secret(mpz_t shared_secret, keys* key_ptr, mpz_t other_party_secret, mpz_t other_party_secret_hash, mpz_t dhe_rand_sec, mpz_t dhe_prime);
