/*
 *  rsa/rsa.c
 *  RSA Signature Scheme
 *  samuel judson | cryptography and network protocols | marlboro college
 */

#include <gmp.h>



/*
 *  Signature Algorithm
 */


void rsa_sign_payload(mpz_t signed_payload, mpz_t payload, mpz_t pri_exp, mpz_t modulus) {
  mpz_powm_sec(signed_payload, payload, pri_exp, modulus);
}



/*
 *  Verification Algorithm
 */



void rsa_verify_signature(mpz_t verified_payload, mpz_t recieved_payload, mpz_t other_pub_exp, mpz_t other_modulus) {
  mpz_powm_sec(verified_payload, recieved_payload, other_pub_exp, other_modulus);
}












