Crypto F14
==========

Code (100% C, not sure what's up with the language identifier for the repo) for my Cryptography and Network Protocols tutorial in the fall of 2014 at Marlboro College. I'm partly working my way through Joshua Davies' book *Implementing SSL/TLS: Using Cryptograph and PKI*, and am partly spinning up my own stuff (with assistance from the GNU MP library in certain spots). The ultimate goal will be to have a client and server able to talk over SSL/TLS, with x509 certificates, DHE_RSA as the key exchange protocol, SERPENT_256 as the symmetric key protocol, and SHA2-512 for any and all hashing purposes.

A piece by piece breakdown.

dhe_rsa
--------

Implementation of textbook Diffie-Hellman Key Agreement Scheme for key distribution and textbook RSA-2048 for signatures. Uses the GNU MP library. Builds a standalone key generation program, in addition to acting as a library.

http_client and http_server
---------------------------

A simple http client and server, pulled pretty much directly from Davies', although like all his code I have some stylistic differences and other minor changes. The server should be able to handle concurrent connections via the pthread library, but it doesn't currently work. Handles single connections fine, however.

serpent
-------

Implementation of the Serpent_256 block cipher. The sboxes themselves (as well as the code to call them) are straight from the original AES competition submission, everything else is built from scratch. Builds as a standalone command line program, in addition to as a library. Currently does not compute test vectors properly, but I haven't had time to investigate, most likely due to vectors being computed by iterative runs of the cipher, or by something shifty with bit representations, due to the submission code being dated to 1998 (and expecting unsigned long to be a 32-bit value). Requires machine to be little-endian, and takes hex-encoded input.

sha2
----

Implementation of SHA2-512. Currently being debugged.

x509
----

Also from Davies', albeit with a bit more editing, mainly to remove his huge library and to use GNU MP instead in addition to formatting, etc. Changeover not finished/tested, need to have SHA2-512 worked out first.

TODO
----
+ Finish SHA2-512.
+ Finish x509 changes.
+ CA and certificate generation.
+ Add SSL/TLS support for client and server. Will probably end up being just TLS 1.0.

A final note...
---------------

I sincerely doubt anyone would come along and plan to use this for anything other than educational purposes, but obviously don't.