/*
 *  cipher_specs.h
 *  definitions of certain cipher specifications
 *  samuel judson | cryptography and network protocols | marlboro college
 */

// used for uint32_t type
#include <stdint.h> 

#define BYTE 1

// Number of bytes in a chunk (32-bits is the size of the prekeys and s-boxes, and therefore a good baseline). uint32_t type generally used to align with this.
#define BYTE_CHUNK_SIZE 4 

#define HEX_CHARS_PER_BYTE 2

// in chunks
#define KEY_LENGTH 8  
#define BLOCK_LENGTH 4 

// length of pre and intermediate keys in chunks
#define P_I_K_LENGTH 4

#define NUM_PREKEYS 8
#define NUM_INTERMEDIATE_KEYS 132

// length of round keys in chunks
#define ROUND_KEY_LENGTH 4 

// only 32 are used, but key scheduling algorithm provides for 33
#define NUM_ROUND_KEYS 33
